/*
  *** PocketMotus GBA ***
 Version 0.1
 Franois PESSAUX June 2004
 This program is freeware.
 Use its sources as you whant provided that you leave this copyright unchanged
 and that you drop a small word telling that I'm the author of these sources.
 Thank's a lot.
   --Francois
*/

#ifndef __GAME_H
#define __GAME_H

#define MAX_STRINGLEN 256
#define MENU_HEIGHT 26

#define WORD_LEN 6
#define NUMBER_OF_TURNS 6
#define BLANK_STRING_INIT "      "

#define BAD_PLACE 0
#define GOOD_PLACE 1
#define JUST_SUBMITTED 2
#define WRONG_LETTER 2   /* Mme couleur que pour les lettres saisies. */

struct game {
  char solution[WORD_LEN+1] ;
  int current_turn ;
  int next_empty_cell ;
  // Letters known and are the right place.
  char current_known_facts[WORD_LEN+1] ;
  char suggestions_history[NUMBER_OF_TURNS][WORD_LEN+1] ;
  // Tableau de WRONG_LETTER, BAD_PLACE, GOOD_PLACE.
  char colors_history[NUMBER_OF_TURNS][WORD_LEN+1] ;
};

extern struct game current_game ;
#define BOARD_LEFT_OFFSET 3
#define BOARD_TOP_OFFSET 5

#define INPUT_LEFT_OFFSET 20
#define INPUT_TOP_OFFSET 13
#define INPUT_RIGHT_OFFSET (INPUT_LEFT_OFFSET + 6)
#define INPUT_BOTTOM_OFFSET (INPUT_TOP_OFFSET + 3)

/* Les tiles de lettres de jeu commencent  l'offset 0. */
#define LETTERS_TILES_OFFSET 0

#define ORDER_VALIDATE_SUGGESTION 26
#define ORDER_UNSELECT_LETTER 27
#define ORDER_INVOKE_PAUSE 28
#define ORDER_ELAPSED_TIME 29


void StartNewGame (void) ;
void TerminateGame (unsigned char) ;
void update_game_status (unsigned char) ;
BOOL LoadGame (void) ;
void SaveGame (void) ;
void GetStats (void) ;
void ClearStats (void) ;

/* Motus Advance Save Game. */
#define HALLFAMEMAGICNUMBER TAGTOLONG('M','A','S','G')

struct hall_fame {
  unsigned long magic ;
  int rand_new_seed ;
  unsigned int nb_won ;
  unsigned int nb_lost ;
  unsigned int nb_surrendered ;
};

extern struct hall_fame current_hall_fame ;

#define WINNER 0
#define LOSER 1
#define SURRENDER 2
#endif
