/*
  *** PocketMotus GBA ***
 Franois PESSAUX June 2004
 This program is freeware.
 Use its sources as you whant provided that you leave this copyright unchanged
 and that you drop a small word telling that I'm the author of these sources.
 Thank's a lot.
   --Francois
*/

#ifndef __GLOBAL_H
#define __GLOBAL_H

typedef unsigned char BOOL ;
#define FALSE 0
#define TRUE 1


#define TAGTOLONG(a,b,c,d) ((unsigned long)(((a)<<24)|((b)<<16)|((c)<<8)|(d)))
#define TABLEMAGICNUMBER TAGTOLONG('M','D','I','C')

/* DAGElement = ULONG. */
/* Bits 0-7 de poids faible = Char */
/* Bit 8 = IsBase | NextFilled */
/* Bit 9 = IsFinal */
/* Bits 10-31 = NextBase */
typedef unsigned long DAGElement ;

#define GETCHAR(foo) \
	((unsigned char) ((foo) & 0xFF))

#define GETISBASE(foo) \
	((foo) & 0x00000100)

#define GETNEXTFILLED(foo) \
	((foo) & 0x00000100)

#define GETISFINAL(foo) \
	((foo) & 0x00000200)

#define GETNEXTBASE(foo) \
	((unsigned long) ((foo) >> 10))

/* VALEUR DU <<POINTEUR>> SIGNIFIANT TRANSITION NON EXISTANTE */
#define END_TRANSITION 0x3FFFFF

extern DAGElement *automaton ;
extern unsigned long automaton_size ;
extern unsigned long initial_state ;

extern const unsigned long french_dic_mapped_memory[] __attribute__ ((section (".rodata"))) ;

extern const unsigned long english_dic_mapped_memory[] __attribute__ ((section (".rodata"))) ;

extern const unsigned long italiano_dic_mapped_memory[] __attribute__ ((section (".rodata"))) ;

#define LANG_FRENCH 0
#define LANG_ENGLISH 1
#define LANG_ITALIANO 2

extern u8 language ;
extern struct game current_game ;
extern BOOL check_flag ;
extern BOOL timer_flag ;

extern u16 *balls_video_memory ;
extern u16 *palette_memory ;
extern u16 *requesters_video_memory ;
extern u16 *background_video_memory ;
extern u16 *sprite_palette ;
extern struct sprite *sprite_video_memory ;

extern unsigned char all_purpose_message_buffer[256] ;

extern u16 key_prev ;
extern u16 key_curr ;

#define KEY_POOL key_prev = key_curr ; key_curr= REG_P1
#define KEY_HIT(key) ((~key_curr & key_prev) & key)

#endif
