/*
  *** PocketMotus GBA ***
 Version 0.1
 Franois PESSAUX June 2004
 This program is freeware.
 Use its sources as you whant provided that you leave this copyright unchanged
 and that you drop a small word telling that I'm the author of these sources.
 Thank's a lot.
   --Francois
*/


#include <stdio.h>
#include <stdlib.h>
#include "../gba.h"
#include "global.h"
#include "requesters.h"



BOOL LoadDictionary () {
  const unsigned long *dic_mapped_memory = NULL ;

  switch (language) {
  case LANG_FRENCH: dic_mapped_memory = french_dic_mapped_memory ; break ;
  case LANG_ENGLISH: dic_mapped_memory = english_dic_mapped_memory ; break ;
  case LANG_ITALIANO: dic_mapped_memory = italiano_dic_mapped_memory ; break ;
  default:
    notify_long_message (FALSE, "LoadDictionary\nASSERT 0") ;
    return (FALSE) ;
    break ;
  }

  /* Check magic word. */
  if (dic_mapped_memory[0] != TABLEMAGICNUMBER) return (FALSE) ;

  /* Check automaton size. */
  automaton_size = dic_mapped_memory[1] ;
  if (automaton_size == 0) return (FALSE) ;

  // Get the initial state
  initial_state = dic_mapped_memory[2] ;

  // Assign the global pointer of the automaton to the mapped memory.
  automaton = (DAGElement*) &dic_mapped_memory[3] ;
  return (TRUE) ;
}

