/*
  *** PocketMotus GBA ***
 Franois PESSAUX June 2004
 This program is freeware.
 Use its sources as you whant provided that you leave this copyright unchanged
 and that you drop a small word telling that I'm the author of these sources.
 Thank's a lot.
   --Francois
*/

#include <stdlib.h>
#include <gba.h>
#include <timer.h>
#include <interrupt.h>
#include "global.h"
#include "loaddic.h"
#include "game.h"
#include "graphics.h"
#include "utils.h"
#include "requesters.h"
#include "messages.h"
#include "starter.h"
#include "ints.h"



int main (void)
{
  unsigned char input_pannel_code ;

  init_sound_handler () ;
  setup_cursor_graphics () ;
  play_intro () ;
  setup_board_graphics () ;

  /* Chargement du dictionnaire. */
  if (!LoadDictionary ()) {
    notify_long_message (FALSE, messages[MSG_DIC_NOT_LOADED][language]) ;
    return (-1) ;
  }

  current_game.current_turn = -1 ;
  /* Initialialisation du gnrateur de nombres alatoires. */
  srand (REG_VCOUNT) ;

  LoadGame () ;
  for (;;) {
    GetStats () ;
    invoke_starter () ;
    rand () ;
    StartNewGame () ;
    while (current_game.current_turn > -1) {
      input_pannel_code = read_user_input_in_game_state () ;
      update_game_status (input_pannel_code) ;
    }
    KEY_POOL ;
    while (1) {
      if ((KEY_HIT (BUTTON_A)) || (KEY_HIT (BUTTON_B)) ||
	  (KEY_HIT (BUTTON_START)) || (KEY_HIT (BUTTON_SELECT))) break ;
      KEY_POOL ;
    }
  }
}

