/*
  *** PocketMotus GBA ***
 Franois PESSAUX June 2004
 This program is freeware.
 Use its sources as you whant provided that you leave this copyright unchanged
 and that you drop a small word telling that I'm the author of these sources.
 Thank's a lot.
   --Francois
*/
#include <gba.h>
#include "motus_play_fonts.h"
#include "global.h"
#include "screen_mode.h"
#include "utils.h"
#include "requesters.h"
#include "char_table.h"



void clear_requester_inside (void)
{
  u8 line, column ;
  u16 blank ;

  blank = (char_to_tile_table[' '] + NB_BALL_FONT_TILES) |
    (STD_FONT_SUBPALETTE_NUMBER << 12) ;
  for (line=0; line<REQUESTER_NB_LINES; line++) {
    for (column=0; column<REQUESTER_NB_COLUMNS; column++)
      requesters_video_memory[((line + REQUESTER_TOP_OFFSET) * (256 / 8)) +
			      (column + REQUESTER_LEFT_OFFSET)] = blank ;
  }
}



void do_print_at (u16 line, u16 column, const unsigned char *str)
{
  u8 i ;
  u16 c ;

  for (i=0; str[i]!='\0'; i++) {
    c = (u16) str[i] ;
    /* Scrolling vertical d au dpassement de la taille horizontale. */
    if (column >= REQUESTER_NB_COLUMNS) {
      column = 0 ;
      line++ ;
    }

    /* Cas du saut de ligne. */
    if (c == '\n') {
      line++ ;
      column = 0 ;
      continue ;
      }

    /* Gestion du scrolling vertical d au */
    /* dpassement de la taille verticale. */
    if (line >= REQUESTER_NB_LINES) {
      /* On affiche une petite flche dans la bordure. */
      requesters_video_memory
	[((REQUESTER_TOP_OFFSET + REQUESTER_NB_LINES + 2) * (256/8)) +
	 (REQUESTER_LEFT_OFFSET + REQUESTER_NB_COLUMNS + 2)] =
	(u16) (NB_BALL_FONT_TILES + TILE_CONTINUE_ARROW) |
	(STD_FONT_SUBPALETTE_NUMBER << 12) ;
      KEY_POOL ;
      while (! KEY_HIT (BUTTON_A)) { KEY_POOL ; }
      clear_requester_inside () ;
      line = 0 ;
      column = 0 ;
    }

    /* Correction pour tomber au bon indice dans la table des tiles. */
    c = char_to_tile_table[c] + NB_BALL_FONT_TILES ;
    requesters_video_memory
      [((line + REQUESTER_TOP_OFFSET) * (256/8)) +
       (column + REQUESTER_LEFT_OFFSET)] =
      (u16) c | (STD_FONT_SUBPALETTE_NUMBER << 12) ;
    column++ ;
  }
}




BOOL notify_long_message (BOOL expect_answer, const unsigned char *str)
{
  u8 line, column ;
  u16 old_screen_mode ;
  BOOL ret_code = FALSE ;

  /* On sauvegarde le mode vido d'origine. */
  old_screen_mode = REG_DISPCNT ;

  /* Effacement de la zone d'affichage. */
  clear_requester_inside () ;

  line = 0 ;
  column = 0 ;
  do_print_at (line, column, str) ;

  /* On autorise l'affichage du layer de requesters */
  /* et on laisse celui du fond.                    */
  set_screen_mode (MODE_0 | BG1_ENABLE | BG2_ENABLE) ;

  if (expect_answer == FALSE) {
    /* On attend une pression sur le bouton A */
    /* pour faire disparatre le tout.        */
    KEY_POOL ;
    while (! KEY_HIT (BUTTON_A)) { KEY_POOL ; }
    ret_code = FALSE ;
  }
  else {
    for (;;) {
      /* On attend une pression sur le bouton A */
      /* ou B pour faire disparatre le tout.     */
      KEY_POOL ;
      if (KEY_HIT (BUTTON_A)) { ret_code = TRUE ; break ; }
      if (KEY_HIT (BUTTON_B)) { ret_code = FALSE ; break ; }
    }
  }

  /* On restaure le mode vido d'origine. */
  set_screen_mode (old_screen_mode) ;

  return (ret_code) ;
}
